"""
This file contains some objects useful for deduplication algorithm.
typeConditorCategory : which map Type COnditor to "revue", "thèse", "ouvrage" or "autre"
titleStopwords : which map stopword title to their normalize form
"""
typeConditorCategory = {
    "Article" : "revue",
    "Conférence" : "revue",
    "Chapitre" : "revue",
    "Thèse" :  "thèse",
    "Ouvrage" : "ouvrage",
    "Rapport" : "ouvrage",
    "Autre" : "autre"
}


titleStopwords = {
    "Introduction": "introduction",
    "Présentation": "presentation",
    "Préface": "preface",
    "Reply": "reply",
    "Editorial": "editorial",
    "Foreword": "foreword",
    "Conclusion": "conclusion",
    "Preface": "preface",
    "Épilogue": "epilogue",
    "France": "france",
    "Prologo": "prologo",
    "introduction": "introduction",
    "Introducción": "introduccion",
    "Conclusions": "conclusions",
    "Prólogo": "prologo",
    "Éditorial": "editorial",
    "Index": "index",
    "Предисловие": "predislovie",
    "Remerciements": "remerciements",
    "Erratum": "erratum",
    "Response": "response",
    "Glossaire": "glossaire",
    "Livres": "livres",
    "Discussion": "discussion",
    "Acknowledgements": "acknowledgements",
    "Manufacturing": "manufacturing",
    "References": "references",
    "Energy": "energy",
    "Bibliography": "bibliography",
    "Transport": "transport",
    "Resumen": "resumen",
    "Finance": "finance",
    "Bibliographie": "bibliographie",
    "Annexes": "annexes",
    "Abbreviations": "abbreviations",
    "Idées": "idees",
    "préface": "preface",
    "Overview": "overview",
    "Conclusión": "conclusion",
    "Mining": "mining",
    "Acronyms": "acronyms",
    "Liminaire": "liminaire",
    "Postface": "postface",
    "Epilogue": "epilogue",
    "REPLY": "reply",
    "Corrigendum": "corrigendum",
    "Sources": "sources",
    "PRÉFACE": "preface",
    "Introduccion": "introduccion",
    "Abréviations": "abreviations",
    "conclusion": "conclusion",
    "OVERVIEW": "overview",
    "introducción": "introduccion",
    "EDITORIAL": "editorial",
    "ПРЕДИСЛОВИЕ": "predislovie",
    "ERRATUM": "erratum",
    "Références": "references",
    "INDEX": "index",
    "Presentation": "presentation",
    "BIBLIOGRAPHY": "bibliography",
    "CORRIGENDUM": "corrigendum",
    "PREFACE": "preface",
    "INTRODUCTION": "introduction"
}

"""
Decision grid for near duplicates validation
there are 5 points columns which are :
    - identifier :
    - pageRange
    - volumaison
    - publishing source
    - title
That is set of five filled of -1,0 or 1
"""

decisionGrid = {

    # id =1, page = 1
    (1,1,0,0,1) : (1,"1id, 1page, 0vol, 0source, 1title"),
    (1,1,0,0,-1) : (0,"1id, 1page, 0vol, 0source, #title"),
    (1,1,0,0,0) : (0,"1id, 1page, 0vol, 0source, 0title"),
    (1,1,0,1,1) : (1,"1id, 1page, 0vol, 1source, 1title"),
    (1,1,0,1,-1) : (0,"1id, 1page, 0vol, 1source, #title"),
    (1,1,0,1,0) : (1,"1id, 1page, 0vol, 1source, 0title"),
    (1,1,0,-1,1) : (0,"1id, 1page, 0vol, #source, 1title"),
    (1,1,0,-1,-1) : (-1,"1id, 1page, 0vol, #source, #title"),
    (1,1,0,-1,0) : (0,"1id, 1page, 0vol, #source, 0title"),

    (1,1,1,0,1) : (1,"1id, 1page, 1vol, 0source, 1title"),
    (1,1,1,0,-1) : (0,"1id, 1page, 1vol, 0source, #title"),
    (1,1,1,0,0) : (1,"1id, 1page, 1vol, 0source, 0title"),
    (1,1,1,1,1) : (1,"1id, 1page, 1vol, 1source, 1title"),
    (1,1,1,1,-1) : (0,"1id, 1page, 1vol, 1source, #title"),
    (1,1,1,1,0) : (1,"1id, 1page, 1vol, 1source, 0title"),
    (1,1,1,-1,1) : (1,"1id, 1page, 1vol, #source, 1title"),
    (1,1,1,-1,-1) : (1,"1id, 1page, 1vol, #source, #title"),
    (1,1,1,-1,0) : (1,"1id, 1page, 1vol, #source, 0title"),

    (1,1,-1,0,1) : (1,"1id, 1page, #vol, 0source, 1title"),
    (1,1,-1,0,-1) : (-1,"1id, 1page, #vol, 0source, #title"),
    (1,1,-1,0,0) : (-1,"1id, 1page, #vol, 0source, 0title"),
    (1,1,-1,1,1) : (1,"1id, 1page, #vol, 1source, 1title"),
    (1,1,-1,1,-1) : (-1,"1id, 1page, #vol, 1source, #title"),
    (1,1,-1,1,0) : (1,"1id, 1page, #vol, 1source, 0title"),
    (1,1,-1,-1,1) : (0,"1id, 1page, #vol, #source, 1title"),
    (1,1,-1,-1,-1) : (-1,"1id, 1page, #vol, #source, #title"),
    (1,1,-1,-1,0) : (-1,"1id, 1page, #vol, #source, 0title"),


    # id = 1 Page = 0
    (1,0,0,0,1) : (0,"1id, 0page, 0vol, 0source, 1title"),
    (1,0,0,0,-1) : (-1,"1id, 0page, 0vol, 0source, #title"),
    (1,0,0,0,0) : (0,"1id, 0page, 0vol, 0source, 0title"),
    (1,0,0,1,1) : (0,"1id, 0page, 0vol, 1source, 1title"),
    (1,0,0,1,-1) : (-1,"1id, 0page, 0vol, 1source, #title"),
    (1,0,0,1,0) : (0,"1id, 0page, 0vol, 1source, 0title"),
    (1,0,0,-1,1) : (-1,"1id, 0page, 0vol, #source, 1title"),
    (1,0,0,-1,-1) : (-1,"1id, 0page, 0vol, #source, #title"),
    (1,0,0,-1,0) : (-1,"1id, 0page, 0vol, #source, 0title"),


    (1,0,1,0,1) : (0,"1id, 0page, 1vol, 0source, 1title"),
    (1,0,1,0,-1) : (-1,"1id, 0page, 1vol, 0source, #title"),
    (1,0,1,0,0) : (0,"1id, 0page, 1vol, 0source, 0title"),
    (1,0,1,1,1) : (1,"1id, 0page, 1vol, 1source, 1title"),
    (1,0,1,1,-1) : (0,"1id, 0page, 1vol, 1source, #title"),
    (1,0,1,1,0) : (0,"1id, 0page, 1vol, 1source, 0title"),
    (1,0,1,-1,1) : (0,"1id, 0page, 1vol, #source, 1title"),
    (1,0,1,-1,-1) : (-1,"1id, 0page, 1vol, #source, #title"),
    (1,0,1,-1,0) : (-1,"1id, 0page, 1vol, #source, 0title"),

    (1,0,-1,0,1) : (0,"1id, 0page, #vol, 0source, 1title"),
    (1,0,-1,0,-1) : (-1,"1id, 0page, #vol, 0source, #title"),
    (1,0,-1,0,0) : (0,"1id, 0page, #vol, 0source, 0title"),
    (1,0,-1,1,1) : (1,"1id, 0page, #vol, 1source, 1title"),
    (1,0,-1,1,-1) : (-1,"1id, 0page, #vol, 1source, #title"),
    (1,0,-1,1,0) : (0,"1id, 0page, #vol, 1source, 0title"),
    (1,0,-1,-1,1) : (-1,"1id, 0page, #vol, #source, 1title"),
    (1,0,-1,-1,-1) : (-1,"1id, 0page, #vol, #source, #title"),
    (1,0,-1,-1,0) : (-1,"1id, 0page, #vol, #source, 0title"),

    # id = 1 Page = -1
    (1,-1,0,0,1) : (-1,"1id, #page, 0vol, 0source, 1title"),
    (1,-1,0,0,-1) : (-1,"1id, #page, 0vol, 0source, #title"),
    (1,-1,0,0,0) : (-1,"1id, #page, 0vol, 0source, 0title"),
    (1,-1,0,1,1) : (-1, "1id, #page, 0vol, 1source, 1title"),
    (1,-1,0,1,-1) : (-1,"1id, #page, 0vol, 1source, #title"),
    (1,-1,0,1,0) : (-1,"1id, #page, 0vol, 1source, 0title"),
    (1,-1,0,-1,1) : (-1,"1id, #page, 0vol, #source, 1title"),
    (1,-1,0,-1,-1) : (-1,"1id, #page, 0vol, #source, #title"),
    (1,-1,0,-1,0) : (-1,"1id, #page, 0vol, #source, 0title"),

    (1,-1,1,0,1) : (-1,"1id, #page, 1vol, 0source, 1title"),
    (1,-1,1,0,-1) : (-1,"1id, #page, 1vol, 0source, #title"),
    (1,-1,1,0,0) : (-1,"1id, #page, 1vol, 0source, 0title"),
    (1,-1,1,1,1) : (1,"1id, #page, 1vol, 1source, 1title"),
    (1,-1,1,1,-1) : (-1,"1id, #page, 1vol, 1source, #title"),
    (1,-1,1,1,0) : (0,"1id, #page, 1vol, 1source, 0title"),
    (1,-1,1,-1,1) : (-1,"1id, #page, 1vol, #source, 1title"),
    (1,-1,1,-1,-1) : (-1,"1id, #page, 1vol, #source, #title"),
    (1,-1,1,-1,0) : (-1,"1id, #page, 1vol, #source, 0title"),

    (1,-1,-1,0,1) : (-1,"1id, #page, #vol, 0source, 1title"),
    (1,-1,-1,0,-1) : (-1,"1id, #page, #vol, 0source, #title"),
    (1,-1,-1,0,0) : (-1,"1id, #page, #vol, 0source, 0title"),
    (1,-1,-1,1,1) : (-1,"1id, #page, #vol, 1source, 1title"),
    (1,-1,-1,1,-1) : (-1,"1id, #page, #vol, 0source, #title"),
    (1,-1,-1,1,0) : (-1,"1id, #page, #vol, 0source, 0title"),
    (1,-1,-1,-1,1) : (-1,"1id, #page, #vol, #source, 1title"),
    (1,-1,-1,-1,-1) : (-1,"1id, #page, #vol, #source, #title"),
    (1,-1,-1,-1,0) : (-1,"1id, #page, #vol, #source, 0title"),

    # id = 0 Page = -1
    (0,-1,0,0,1) : (0,"0id, #page, 0vol, 0source, 1title"),
    (0,-1,0,0,-1) : (-1,"0id, #page, 0vol, 0source, #title"),
    (0,-1,0,0,0) : (0,"0id, #page, 0vol, 0source, 0title"),
    (0,-1,0,1,1) : (-1, "0id, #page, 0vol, 1source, 1title"),
    (0,-1,0,1,-1) : (-1,"0id, #page, 0vol, 1source, #title"),
    (0,-1,0,1,0) : (0,"0id, #page, 0vol, 1source, 0title"),
    (0,-1,0,-1,1) : (-1,"0id, #page, 0vol, #source, 1title"),
    (0,-1,0,-1,-1) : (-1,"0id, #page, 0vol, #source, #title"),
    (0,-1,0,-1,0) : (-1,"0id, #page, 0vol, #source, 0title"),

    (0,-1,1,0,1) : (-1,"0id, #page, 1vol, 0source, 1title"),
    (0,-1,1,0,-1) : (-1,"0id, #page, 1vol, 0source, #title"),
    (0,-1,1,0,0) : (0,"0id, #page, 1vol, 0source, 0title"),
    (0,-1,1,1,1) : (-1,"0id, #page, 1vol, 1source, 1title"),
    (0,-1,1,1,-1) : (-1,"0id, #page, 1vol, 1source, #title"),
    (0,-1,1,1,0) : (0,"0id, #page, 1vol, 1source, 0title"),
    (0,-1,1,-1,1) : (-1,"0id, #page, 1vol, #source, 1title"),
    (0,-1,1,-1,-1) : (-1,"0id, #page, 1vol, #source, #title"),
    (0,-1,1,-1,0) : (-1,"0id, #page, 1vol, #source, 0title"),

    (0,-1,-1,0,1) : (-1,"0id, #page, #vol, 0source, 1title"),
    (0,-1,-1,0,-1) : (-1,"0id, #page, #vol, 0source, #title"),
    (0,-1,-1,0,0) : (-1,"0id, #page, #vol, 0source, 0title"),
    (0,-1,-1,1,1) : (-1,"0id, #page, #vol, 1source, 1title"),
    (0,-1,-1,1,-1) : (-1,"0id, #page, #vol, 0source, #title"),
    (0,-1,-1,1,0) : (-1,"0id, #page, #vol, 0source, 0title"),
    (0,-1,-1,-1,1) : (-1,"0id, #page, #vol, #source, 1title"),
    (0,-1,-1,-1,-1) : (-1,"0id, #page, #vol, #source, #title"),
    (0,-1,-1,-1,0) : (-1,"0id, #page, #vol, #source, 0title"),


# id = 0 Page = 0
    (0,0,0,0,1) : (0,"0id, 0page, 0vol, 0source, 1title"),
    (0,0,0,0,-1) : (0,"0id, 0page, 0vol, 0source, #title"),
    (0,0,0,0,0) : (0,"0id, 0page, 0vol, 0source, 0title"),
    (0,0,0,1,1) : (0, "0id, 0page, 0vol, 1source, 1title"),
    (0,0,0,1,-1) : (0,"0id, 0page, 0vol, 1source, #title"),
    (0,0,0,1,0) : (0,"0id, 0page, 0vol, 1source, 0title"),
    (0,0,0,-1,1) : (0,"0id, 0page, 0vol, #source, 1title"),
    (0,0,0,-1,-1) : (-1,"0id, 0page, 0vol, #source, #title"),
    (0,0,0,-1,0) : (-1,"0id, 0page, 0vol, #source, 0title"),

    (0,0,1,0,1) : (0,"0id, 0page, 1vol, 0source, 1title"),
    (0,0,1,0,-1) : (0,"0id, 0page, 1vol, 0source, #title"),
    (0,0,1,0,0) : (0,"0id, 0page, 1vol, 0source, 0title"),
    (0,0,1,1,1) : (0,"0id, 0page, 1vol, 1source, 1title"),
    (0,0,1,1,-1) : (-1,"0id, 0page, 1vol, 1source, #title"),
    (0,0,1,1,0) : (0,"0id, 0page, 1vol, 1source, 0title"),
    (0,0,1,-1,1) : (-1,"0id, 0page, 1vol, #source, 1title"),
    (0,0,1,-1,-1) : (-1,"0id, 0page, 1vol, #source, #title"),
    (0,0,1,-1,0) : (0,"0id, 0page, 1vol, #source, 0title"),

    (0,0,-1,0,1) : (0,"0id, 0page, #vol, 0source, 1title"),
    (0,0,-1,0,-1) : (-1,"0id, 0page, #vol, 0source, #title"),
    (0,0,-1,0,0) : (-1,"0id, 0page, #vol, 0source, 0title"),
    (0,0,-1,1,1) : (0,"0id, 0page, #vol, 1source, 1title"),
    (0,0,-1,1,-1) : (-1,"0id, 0page, #vol, 1source, #title"),
    (0,0,-1,1,0) : (0,"0id, 0page, #vol, 1source, 0title"),
    (0,0,-1,-1,1) : (-1,"0id, 0page, #vol, #source, 1title"),
    (0,0,-1,-1,-1) : (-1,"0id, 0page, #vol, #source, #title"),
    (0,0,-1,-1,0) : (-1,"0id, 0page, #vol, #source, 0title"),

# id = 0 Page = 1
    (0,1,0,0,1) : (0,"0id, 1page, 0vol, 0source, 1title"),
    (0,1,0,0,-1) : (0,"0id, 1page, 0vol, 0source, #title"),
    (0,1,0,0,0) : (0,"0id, 1page, 0vol, 0source, 0title"),
    (0,1,0,1,1) : (0, "0id, 1page, 0vol, 1source, 1title"),
    (0,1,0,1,-1) : (-1,"0id, 1page, 0vol, 1source, #title"),
    (0,1,0,1,0) : (0,"0id, 1page, 0vol, 1source, 0title"),
    (0,1,0,-1,1) : (-1,"0id, 1page, 0vol, #source, 1title"),
    (0,1,0,-1,-1) : (-1,"0id, 1page, 0vol, #source, #title"),
    (0,1,0,-1,0) : (0,"0id, 1page, 0vol, #source, 0title"),

    (0,1,1,0,1) : (0,"0id, 1page, 1vol, 0source, 1title"),
    (0,1,1,0,-1) : (0,"0id, 1page, 1vol, 0source, #title"),
    (0,1,1,0,0) : (0,"0id, 1page, 1vol, 0source, 0title"),
    (0,1,1,1,1) : (1,"0id, 1page, 1vol, 1source, 1title"),
    (0,1,1,1,-1) : (0,"0id, 1page, 1vol, 1source, #title"),
    (0,1,1,1,0) : (0,"0id, 1page, 1vol, 1source, 0title"),
    (0,1,1,-1,1) : (0,"0id, 1page, 1vol, #source, 1title"),
    (0,1,1,-1,-1) : (-1,"0id, 1page, 1vol, #source, #title"),
    (0,1,1,-1,-0) : (0,"0id, 1page, 1vol, #source, 0title"),

    (0,1,-1,0,1) : (-1,"0id, 1page, #vol, 0source, 1title"),
    (0,1,-1,0,-1) : (-1,"0id, 1page, #vol, 0source, #title"),
    (0,1,-1,0,0) : (0,"0id, 1page, #vol, 0source, 0title"),
    (0,1,-1,1,1) : (0,"0id, 1page, #vol, 1source, 1title"),
    (0,1,-1,1,-1) : (-1,"0id, 1page, #vol, 1source, #title"),
    (0,1,-1,1,0) : (0,"0id, 1page, #vol, 1source, 0title"),
    (0,1,-1,-1,1) : (-1,"0id, 1page, #vol, #source, 1title"),
    (0,1,-1,-1,-1) : (-1,"0id, 1page, #vol, #source, #title"),
    (0,1,-1,-1,0) : (-1,"0id, 1page, #vol, #source, 0title"),


# id = -1 Page = -1
    (-1,-1,0,0,1) : (-1,"#id, #page, 0vol, 0source, 1title"),
    (-1,-1,0,0,-1) : (-1,"#id, #page, 0vol, 0source, #title"),
    (-1,-1,0,0,0) : (-1,"#id, #page, 0vol, 0source, 0title"),
    (-1,-1,0,1,1) : (-1, "#id, #page, 0vol, 1source, 1title"),
    (-1,-1,0,1,-1) : (-1,"#id, #page, 0vol, 1source, #title"),
    (-1,-1,0,1,0) : (0,"#id, #page, 0vol, 1source, 0title"),
    (-1,-1,0,-1,1) : (-1,"#id, #page, 0vol, #source, 1title"),
    (-1,-1,0,-1,-1) : (-1,"#id, #page, 0vol, #source, #title"),
    (-1,-1,0,-1,0) : (-1,"#id, #page, 0vol, #source, 0title"),

    (-1,-1,1,0,1) : (-1,"#id, #page, 1vol, 0source, 1title"),
    (-1,-1,1,0,-1) : (-1,"#id, #page, 1vol, 0source, #title"),
    (-1,-1,1,0,0) : (-1,"#id, #page, 1vol, 0source, 0title"),
    (-1,-1,1,1,1) : (-1,"#id, #page, 1vol, 1source, 1title"),
    (-1,-1,1,1,-1) : (-1,"#id, #page, 1vol, 1source, #title"),
    (-1,-1,1,1,0) : (-1,"#id, #page, 1vol, 1source, 0title"),
    (-1,-1,1,-1,1) : (-1,"#id, #page, 1vol, #source, 1title"),
    (-1,-1,1,-1,-1) : (-1,"#id, #page, 1vol, #source, #title"),
    (-1,-1,1,-1,0) : (-1,"#id, #page, 1vol, #source, 0title"),

    (-1,-1,-1,0,1) : (-1,"#id, #page, #vol, 0source, 1title"),
    (-1,-1,-1,0,-1) : (-1,"#id, #page, #vol, 0source, #title"),
    (-1,-1,-1,0,0) : (-1,"#id, #page, #vol, 0source, 0title"),
    (-1,-1,-1,1,1) : (-1,"#id, #page, #vol, 1source, 1title"),
    (-1,-1,-1,1,-1) : (-1,"#id, #page, #vol, 1source, #title"),
    (-1,-1,-1,1,0) : (-1,"#id, #page, #vol, 1source, 0title"),
    (-1,-1,-1,-1,1) : (-1,"#id, #page, #vol, #source, 1title"),
    (-1,-1,-1,-1,-1) : (-1,"#id, #page, #vol, #source, #title"),
    (-1,-1,-1,1,-1) : (-1,"#id, #page, #vol, #source, 0title"),

# id = -1 Page = 0
    (-1,0,0,0,1) : (-1,"#id, 0page, 0vol, 0source, 1title"),
    (-1,0,0,0,-1) : (-1,"#id, 0page, 0vol, 0source, #title"),
    (-1,0,0,0,0) : (0,"#id, 0page, 0vol, 0source, 0title"),
    (-1,0,0,1,1) : (-1, "#id, 0page, 0vol, 1source, 1title"),
    (-1,0,0,1,-1) : (-1,"#id, 0page, 0vol, 1source, #title"),
    (-1,0,0,1,0) : (0,"#id, 0page, 0vol, 1source, 0title"),
    (-1,0,0,-1,1) : (-1,"#id, 0page, 0vol, #source, 1title"),
    (-1,0,0,-1,-1) : (-1,"#id, 0page, 0vol, #source, #title"),
    (-1,0,0,-1,0) : (-1,"#id, 0page, 0vol, #source, 0title"),

    (-1,0,1,0,1) : (-1,"#id, 0page, 1vol, 0source, 1title"),
    (-1,0,1,0,-1) : (-1,"#id, 0page, 1vol, 0source, #title"),
    (-1,0,1,0,0) : (0,"#id, 0page, 1vol, 0source, 0title"),
    (-1,0,1,1,1) : (-1,"#id, 0page, 1vol, 1source, 1title"),
    (-1,0,1,1,-1) : (-1,"#id, 0page, 1vol, 1source, #title"),
    (-1,0,1,1,0) : (0,"#id, 0page, 1vol, 1source, 0title"),
    (-1,0,1,-1,1) : (-1,"#id, 0page, 1vol, #source, 1title"),
    (-1,0,1,-1,-1) : (-1,"#id, 0page, 1vol, #source, #title"),
    (-1,0,1,-1,0) : (-1,"#id, 0page, 1vol, #source, 0title"),

    (-1,0,-1,0,1) : (-1,"#id, 0page, #vol, 0source, 1title"),
    (-1,0,-1,0,-1) : (-1,"#id, 0page, #vol, 0source, #title"),
    (-1,0,-1,0,0) : (-1,"#id, 0page, #vol, 0source, 0title"),
    (-1,0,-1,1,1) : (-1,"#id, 0page, #vol, 1source, 1title"),
    (-1,0,-1,1,-1) : (-1,"#id, 0page, #vol, 1source, #title"),
    (-1,0,-1,1,0) : (-1,"#id, 0page, #vol, 1source, 0title"),
    (-1,0,-1,-1,1) : (-1,"#id, 0page, #vol, #source, 1title"),
    (-1,0,-1,-1,-1) : (-1,"#id, 0page, #vol, #source, #title"),
    (-1,0,-1,-1,0) : (-1,"#id, 0page, #vol, #source, 0title"),

# id = -1 Page = 1
    (-1,1,0,0,1) : (-1,"#id, 1page, 0vol, 0source, 1title"),   # automate =>  Non doublons (dans le doute)
    (-1,1,0,0,-1) : (-1,"#id, 1page, 0vol, 0source, #title"),
    (-1,1,0,0,0) : (0,"#id, 1page, 0vol, 0source, 0title"),
    (-1,1,0,1,1) : (-1, "#id, 1page, 0vol, 1source, 1title"),
    (-1,1,0,1,-1) : (-1,"#id, 1page, 0vol, 1source, #title"),
    (-1,1,0,1,0) : (-1,"#id, 1page, 0vol, 1source, 0title"),
    (-1,1,0,-1,1) : (-1,"#id, 1page, 0vol, #source, 1title"),
    (-1,1,0,-1,-1) : (-1,"#id, 1page, 0vol, #source, #title"),
    (-1,1,0,-1,0) : (-1,"#id, 1page, 0vol, #source, 0title"),

    (-1,1,1,0,1) : (-1,"#id, 1page, 1vol, 0source, 1title"),
    (-1,1,1,0,-1) : (-1,"#id, 1page, 1vol, 0source, #title"),
    (-1,1,1,0,0) : (0,"#id, 1page, 1vol, 0source, 0title"),
    (-1,1,1,1,1) : (0,"#id, 1page, 1vol, 1source, 1title"),
    (-1,1,1,1,-1) : (-1,"#id, 1page, 1vol, 1source, #title"),
    (-1,1,1,1,0) : (-1,"#id, 1page, 1vol, 1source, 0title"),
    (-1,1,1,-1,1) : (-1,"#id, 1page, 1vol, #source, 1title"),
    (-1,1,1,-1,-1) : (-1,"#id, 1page, 1vol, #source, #title"),
    (-1,1,1,-1,0) : (-1,"#id, 1page, 1vol, #source, 0title"),

    (-1,1,-1,0,1) : (-1,"#id, 1page, #vol, 0source, 1title"),
    (-1,1,-1,0,-1) : (-1,"#id, 1page, #vol, 0source, #title"),
    (-1,1,-1,0,0) : (-1,"#id, 1page, #vol, 0source, 0title"),
    (-1,1,-1,1,1) : (-1,"#id, 1page, #vol, 1source, 1title"),
    (-1,1,-1,1,-1) : (-1,"#id, 1page, #vol, 1source, #title"),
    (-1,1,-1,1,0) : (-1,"#id, 1page, #vol, 1source, 0title"),
    (-1,1,-1,-1,1) : (-1,"#id, 1page, #vol, #source, 1title"),
    (-1,1,-1,-1,-1) : (-1,"#id, 1page, #vol, #source, #title"),
    (-1,1,-1,-1,0) : (-1,"#id, 1page, #vol, #source, 0title"),
}
